/* ******************************************************************

   author     : puehringer edgar

   compiler   : javac (jdk 1.1.5)

   class      : DateDupel
   date       : 20.02.98
   description: two dates connected to a dupel

*********************************************************************/

/* ******************************************************************
   import statements
*********************************************************************/

import java.util.*;

/* ******************************************************************
   top level class declaration
*********************************************************************/

public class DateDupel {

  // instance variable declarations
  public Date start;
  public Date end;

  // constructors
  public DateDupel() {
    start = new Date();
    end   = new Date(start.getTime());
  } // end constructor DateDupel

  public DateDupel(long startDate, long endDate) {
    start = new Date(startDate);
    end   = new Date(endDate);
  } // end constructor DateDupel

  // methods
  public boolean startsIn(DateDupel dateDupel) {
    return (!start.before(dateDupel.start)) &&
           (start.before(dateDupel.end));
  } // end startsIn

  public boolean startsInOrExtends(DateDupel dateDupel) {
    return !((start.before(dateDupel.start)) ||
             (start.after(dateDupel.end)));
  } // end startsInOrExtends

  public boolean startInAfterAndEndsInBefore(DateDupel dateDupel) {
    return (start.after(dateDupel.start)) &&
           (end.before(dateDupel.end));
  } // end startInAfterAndEndsInBefore

  public boolean isIn(DateDupel dateDupel) {
    return (!start.before(dateDupel.start)) &&
           (!end.after(dateDupel.end));
  } // end isIn

  public boolean before(DateDupel dateDupel) {
    return (!end.after(dateDupel.start));
  } // end before

  public boolean after(DateDupel dateDupel) {
    return (!start.before(dateDupel.end));
  } // end after

  public boolean overlaps(DateDupel dateDupel) {
    return !(before(dateDupel) || after(dateDupel));
  } // end overlaps

  public void extendEnd(DateDupel dateDupel) {
    if (dateDupel.end.after(end))
      end.setTime(dateDupel.end.getTime());
  } // end extendEnd

  public void clip(DateDupel dateDupel) {
    Assert.assert(!this.isIn(dateDupel));
    if ((!dateDupel.start.after(start)) &&
        (dateDupel.end.after(start))) {
      start.setTime(dateDupel.end.getTime());
    } else if ((dateDupel.start.before(end)) &&
               (!dateDupel.end.before(end))) {
      end.setTime(dateDupel.start.getTime());
    } // end if
  } // end clip

} // end DateDupel

/* ******************************************************************
   end of file
*********************************************************************/
