MODULE Counters; (* JT 30.6.89 HM 13.2.92 *)

TYPE
	Counter* = POINTER TO CounterDesc;
	CounterDesc* = RECORD
		min*, max*, count*, sum, sqsum: LONGINT;
	END;
	
PROCEDURE (c: Counter) Count* (val: LONGINT);
BEGIN
	INC(c.count);
	IF val < c.min THEN c.min := val END;
	IF val > c.max THEN c.max := val END;
	INC(c.sum, val);
	INC(c.sqsum, val * val);
END Count;

PROCEDURE (c: Counter) CountWeight* (val, weight: LONGINT);
BEGIN
	INC(c.count, weight);
	IF val < c.min THEN c.min := val END;
	IF val > c.max THEN c.max := val END;
	INC(c.sum, val * weight);
	INC(c.sqsum, val * val * weight);
END CountWeight;

PROCEDURE (c: Counter) Mean* (): REAL;
BEGIN
	RETURN c.sum / c.count
END Mean;

PROCEDURE (c: Counter) Variance* (): REAL;
	VAR m: REAL;
BEGIN
	m := c.Mean();
	RETURN c.sqsum / c.count - m * m
END Variance;

PROCEDURE (c: Counter) Init*;
BEGIN c.min := MAX(LONGINT); c.max := MIN(LONGINT); c.count := 0; c.sum := 0; c.sqsum := 0
END Init;

END Counters.
